SystemOrganization addCategory: #'Mustache-Seaside'!
SystemOrganization addCategory: #'Mustache-Seaside-Example'!

!WAHtmlCanvas methodsFor: '*mustache-seaside' stamp: 'JesusMari 12/5/2012 15:36'!
mustache
	^ ( WAMustacheTag on:self)! !

MustacheTemplate subclass: #MustacheCounterTemplate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Seaside-Example'!

!MustacheCounterTemplate methodsFor: 'as yet unclassified' stamp: 'JesusMari 12/9/2012 10:30'!
render
^'<h1>Mustache Counter:{{counter}}</h1>

<p>Hello "Seaside code" passed through a View to Mustache </p>

{{{seasideContent}}}

{{[
	html paragraph:''Hello again from seaside inside a square bracket''.
	html paragraph:aView asString.
]}}

{{>Partial3}}'! !

MustacheCounterTemplate subclass: #Partial3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Seaside-Example'!

!Partial3 methodsFor: 'as yet unclassified' stamp: 'JesusMari 12/9/2012 13:06'!
render

^'{{[ 
		html heading: (aView at:''counter'').
	]}}'! !

!Mustache methodsFor: '*mustache-seaside' stamp: 'JesusMari 12/8/2012 08:31'!
renderTemplateAt: aTemplate view:aView on:htmlCanvas
"High-level function that renders the given 'template' located in the partials node, using the given 'view'  If you need to use any of the template options (see #compile method, you must compile in a separate step, and then call that compiled block) "

self html:htmlCanvas.
^ self render: (self class clearComma:(self at:aTemplate)) view:aView.! !

WAExampleComponent subclass: #MustacheCounter
	instanceVariableNames: 'count mustacheInstance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Seaside-Example'!

!MustacheCounter class methodsFor: 'accessing' stamp: 'JesusMari 12/3/2012 11:51'!
description
	^ 'A very simple Seaside/Mustache application'! !

!MustacheCounter class methodsFor: 'examples' stamp: 'JesusMari 12/3/2012 11:08'!
example
	^ self new! !

!MustacheCounter class methodsFor: 'accessing' stamp: 'JesusMari 12/3/2012 11:50'!
handlerName
	^ 'examples/mustacheCounter'! !

!MustacheCounter class methodsFor: 'initialization' stamp: 'JesusMari 12/3/2012 11:08'!
initialize
	WAAdmin register: self asApplicationAt: self handlerName! !

!MustacheCounter methodsFor: 'accessing' stamp: 'JesusMari 12/3/2012 11:08'!
count
	^ count! !

!MustacheCounter methodsFor: 'accessing' stamp: 'JesusMari 12/3/2012 11:08'!
count: anInteger
	count := anInteger! !

!MustacheCounter methodsFor: 'actions' stamp: 'JesusMari 12/3/2012 11:08'!
decrease
	count := count - 1! !

!MustacheCounter methodsFor: 'actions' stamp: 'JesusMari 12/3/2012 11:08'!
increase
	count := count + 1! !

!MustacheCounter methodsFor: 'initialization' stamp: 'JesusMari 12/5/2012 15:37'!
initialize
	super initialize.
	self count: 0! !

!MustacheCounter methodsFor: 'rendering' stamp: 'JesusMari 12/9/2012 08:33'!
renderContentOn: html
	html mustache 
			basePath:'D:\smalltalk\SCouchViewServer\templates\';
			template:'counter';
			view: (JsonObject fromAssociations: {
						'counter'-> self count.
						'seasideContent'->[:stack : htmlCanvas|
							htmlCanvas heading: count.
							htmlCanvas anchor
								callback: [ self increase ];
								with: '++'.
							htmlCanvas space.
							htmlCanvas anchor
								callback: [ self decrease ];
								with: '--'
							]
					}).
	! !

!MustacheCounter methodsFor: 'accessing' stamp: 'JesusMari 12/3/2012 11:08'!
states
	^ Array with: self! !

WAExampleComponent subclass: #MustacheCounter2
	instanceVariableNames: 'count mustacheInstance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Seaside-Example'!

!MustacheCounter2 class methodsFor: 'accessing' stamp: 'JesusMari 12/5/2012 16:07'!
description
	^ 'A very simple Seaside/Mustache application'! !

!MustacheCounter2 class methodsFor: 'examples' stamp: 'JesusMari 12/5/2012 16:07'!
example
	^ self new! !

!MustacheCounter2 class methodsFor: 'accessing' stamp: 'JesusMari 12/5/2012 16:20'!
handlerName
	^ 'examples/mustacheCounter2'! !

!MustacheCounter2 class methodsFor: 'initialization' stamp: 'JesusMari 12/5/2012 16:07'!
initialize
	WAAdmin register: self asApplicationAt: self handlerName! !

!MustacheCounter2 methodsFor: 'accessing' stamp: 'JesusMari 12/5/2012 16:07'!
count
	^ count! !

!MustacheCounter2 methodsFor: 'accessing' stamp: 'JesusMari 12/5/2012 16:07'!
count: anInteger
	count := anInteger! !

!MustacheCounter2 methodsFor: 'actions' stamp: 'JesusMari 12/5/2012 16:07'!
decrease
	count := count - 1! !

!MustacheCounter2 methodsFor: 'actions' stamp: 'JesusMari 12/5/2012 16:07'!
increase
	count := count + 1! !

!MustacheCounter2 methodsFor: 'initialization' stamp: 'JesusMari 12/5/2012 16:07'!
initialize
	super initialize.
	self count: 0! !

!MustacheCounter2 methodsFor: 'rendering' stamp: 'JesusMari 12/9/2012 08:36'!
renderContentOn: html

	html mustache 
			template:MustacheCounterTemplate;
			view: (JsonObject fromAssociations: {
						'counter'-> self count.
						'seasideContent'->[:stack :htmlCanvas|
							htmlCanvas heading: count.
							htmlCanvas anchor
								callback: [ self increase ];
								with: '++'.
							htmlCanvas space.
							htmlCanvas anchor
								callback: [ self decrease ];
								with: '--'
							]
					}).
	! !

!MustacheCounter2 methodsFor: 'accessing' stamp: 'JesusMari 12/5/2012 16:07'!
states
	^ Array with: self! !

Object subclass: #WAMustacheTag
	instanceVariableNames: 'mustacheInstance template html'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Seaside'!

!WAMustacheTag class methodsFor: 'as yet unclassified' stamp: 'JesusMari 12/8/2012 12:03'!
on:html
	| i |
	i:=self new.
	i html:html.
	^i! !

!WAMustacheTag methodsFor: 'as yet unclassified' stamp: 'JesusMari 12/5/2012 15:33'!
basePath: aCompletePath
mustacheInstance ifNil:[mustacheInstance:=Mustache instanceFromFolder:aCompletePath]
! !

!WAMustacheTag methodsFor: 'as yet unclassified' stamp: 'JesusMari 12/5/2012 15:41'!
html: aCanvas
html:=aCanvas! !

!WAMustacheTag methodsFor: 'as yet unclassified' stamp: 'JesusMari 12/5/2012 15:24'!
template:aTemplate
template:=aTemplate! !

!WAMustacheTag methodsFor: 'as yet unclassified' stamp: 'JesusMari 12/5/2012 15:29'!
template:aTemplate view:aView
self template:aTemplate.
self view:aView.
! !

!WAMustacheTag methodsFor: 'as yet unclassified' stamp: 'JesusMari 12/5/2012 16:27'!
view: aView
(template isKindOf:String) ifTrue:[
	mustacheInstance renderTemplateAt: template view:aView on:html.
	].
(template class superclass = MustacheTemplate class)  ifTrue:[
	Mustache toHtml: template view:aView on:html.
	]! !
MustacheCounter2 initialize!
MustacheCounter initialize!
